#!/usr/bin/perl -l

# installs the launcher in /usr/local/share and creates links in
# /usr/local/bin

$alp       = 'ansys_launcher.pl';
$inst_dir  = '/usr/local/share';
$link_dir  = '/usr/local/bin';

print("Copying $alp to $inst_dir");
$copy_cmd = "/bin/cp $alp $inst_dir";
system($copy_cmd) && die("Couldn't execute \"$copy_cmd\": $!");
chmod(oct(755), "$inst_dir/$alp")
  || warn("Couldn't chmod() \"$inst_dir/$alp\": $!");

open(APPLIST, "$inst_dir/$alp -applist|")
  || die("Couldn't execute \"$inst_dir/$alp\": $!");
chdir($link_dir) || die("Couldn't chdir() to \"$link_dir\": $!");
while(<APPLIST>) {
   ($f, $p) = /^\s*([^,]+),(.+\S)\s*$/;
   if($f eq 'ansys_inc') {
      $ansys_inc = $p;
   } else {
      $applist->{$f}->{PATH} = $p;
   }
}
close(APPLIST);

opendir(ANSYS_INC, $ansys_inc)
  || die("Couldn't opendir() on \"$ansys_inc\": $!");
while($_ = readdir(ANSYS_INC)) {
   next unless /^v(\d{3})/;
   push(@versions, $1);
}
closedir(ANSYS_INC);

for(keys(%{$applist})) {
   for $v (@versions) {
      $p = $applist->{$_}->{PATH};
      $p =~ s@_VERSION_@$v@g;
      if(-e $p) {
         ++$applist->{$_}->{VERSIONS}->{$v};
      }
   }
}

for(keys(%{$applist})) {
   if(!(0 == scalar(keys(%{$applist->{$_}->{VERSIONS}})))) {
      if(!(-e $_)) {
         print("Creating \"$_\" link in $link_dir");
         symlink("$inst_dir/$alp", $_);
      }
      for $v (sort(keys(%{$applist->{$_}->{VERSIONS}}))) {
         ($sv) = $v =~ /(\d{2})/;
         for $x ($v, $sv) {
            $f = "$_$x";
            if(!(-e $f)) {
               print("Creating \"$f\" link in $link_dir");
               symlink("$inst_dir/$alp", $f);
            }
         }
      }
   }
}
